/***************************************************************
 Copyright: 2016-2019 ROS小课堂 www.corvin.cn
 Author: corvin
 Description:
    Define servo class and servo pin etc. 
 History:
   20181128: initial this comment.
   20181130: 新增了舵机使能状态的标识，而且最多可接12个舵机。
   20181204: 新增getCurrentPos()函数用户获取当前舵机的角度。
*************************************************************/
#ifndef SERVOS_H
#define SERVOS_H

#define  N_SERVOS  6

#define  SERVO_ENABLE   1
#define  SERVO_DISABLE  0

// Define All Servos's Pins
byte myServoPins[N_SERVOS] = {3, 5, 6, 9, 10, 11};

// Initial Servo Position [0, 160] degrees
byte servoInitPosition[N_SERVOS] = {80, 150, 160, 80, 20, 80};

class SweepServo
{
  public:
    SweepServo();
    void initServo(byte servoPin, unsigned int initPosition, unsigned int stepDelayMs);
    void setTargetPos(unsigned int targetPos, unsigned int stepDelayMs);
    byte getCurrentPos(void);
    void setEnable(byte flag);
    void moveServo(void);
    byte isEnabled(void);
    Servo getServoObj();

  private:
    Servo servo;
    unsigned int stepDelayMs;
    unsigned long lastMoveTime;
    byte currentPosDegrees;
    byte targetPosDegrees;
    byte enabled;
};

SweepServo myServos[N_SERVOS];

#endif
