#include <ros/ros.h>
#include <actionlib/server/simple_action_server.h>
#include <control_msgs/FollowJointTrajectoryActionGoal.h>
#include <control_msgs/FollowJointTrajectoryActionResult.h>
#include <control_msgs/FollowJointTrajectoryAction.h>
#include <sensor_msgs/JointState.h>
#include <iostream>
#include <string.h>
#include <stdio.h>
#include <vector>

using namespace std;

class FollowJointTrajectoryAction
{
    public:
        FollowJointTrajectoryAction(string name):
            as_(nh_, name, false), action_name_(name)
    {
        as_.registerGoalCallback(boost::bind(&FollowJointTrajectoryAction::goalCB, this));
        as_.registerPreemptCallback(boost::bind(&FollowJointTrajectoryAction::preemptCB, this));
        as_.start();
        ROS_INFO("Follow Joint Trajectory Action start...");
    }

    ~FollowJointTrajectoryAction(void)
    {

    }

    void goalCB()
    {
        ROS_INFO("Now in joint trajectory goal callback function...");
        if(as_.isNewGoalAvailable())
        {

        }
        else
        {
            ROS_WARN("Goal isn't available !");
        }

        control_msgs::FollowJointTrajectoryResult result;
        result.error_code = 0;
        as_.setSucceeded(result);
    }

    void preemptCB()
    {
        ROS_WARN("%s:Preempted", action_name_.c_str());
        as_.setPreempted();
    }

    protected:
        ros::NodeHandle nh_;
        actionlib::SimpleActionServer<control_msgs::FollowJointTrajectoryAction> as_;
        string action_name_;
};

int main(int argc, char **argv)
{
    ros::init(argc, argv, "robot_arm_action_server_node");
    FollowJointTrajectoryAction followJoint("robot_arm_controller/follow_joint_trajectory");
    ros::spin();

    return 0;
}
